using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace Client
{
   

    class Client
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            try
            {
                //Enregistrer le canal TCP port 1234
                TcpChannel chnl_1 = new TcpChannel();
                //Pour VS2003
                //ChannelServices.RegisterChannel(chnl_1);
                //Pour VS2005
                ChannelServices.RegisterChannel(chnl_1,true);
                //Prendre la rfrence sur le serveur (tcp://nommachine:port/CompteurManager)
                IRemote.ICompteur CompteurDistant =
(IRemote.ICompteur)Activator.GetObject(typeof(IRemote.ICompteur), "tcp://localhost:1234/CompteurManager");
                //Verifier que la refrence au serveur a t acquise
                if (CompteurDistant == null)
                {
                    Console.WriteLine("Rfrence non acquise");
                }
                else
                {
                    Console.WriteLine("Rfrence au serveur acquise ");
                    //On peut  prsent appeler les mthodes CompteurDistant
                    CompteurDistant.Augmenter(2);
                    //Attendre les instructions sur la console...
                    Console.ReadLine();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("ERREUR :" + ex.Message);
            }
        }
    }

}
