using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace Serveur
{
    public class CompteurManager : MarshalByRefObject, IRemote.ICompteur
    {
        //C'est cet objet que l'on distribue sur le rseau

        DemarreServeur myclass = new DemarreServeur();
        //C'est cette classe que l'on distribue sur le reseau
        public override object InitializeLifetimeService()
        {
            //Dure de vie de l'objet : pour "toujours"
            return null;
        }
        public void Augmenter(double dMontant)
        {
            myclass.monCompteur.Augmenter(dMontant);
        }

    }
    public class RemotingServer
    {
        //Ce code va publier notre objet CompteurManager
        public void Start()
        {
            int canal;
            //Ouvre un canal en mode TCP sur le port '1234'
            canal = 1234;
            TcpChannel chnl_1 = new TcpChannel(canal);
            ChannelServices.RegisterChannel(chnl_1, true);

            //Publie notre objet CompteurManager
            RemotingConfiguration.RegisterWellKnownServiceType(typeof(CompteurManager),"CompteurManager",WellKnownObjectMode.Singleton);
        }

    }
}
